=== modified file 'bzrlib/tests/TestUtil.py'
--- bzrlib/tests/TestUtil.py	2011-05-26 18:02:21 +0000
+++ bzrlib/tests/TestUtil.py	2011-05-26 20:41:53 +0000
@@ -89,6 +89,7 @@
         if stream is None:
             stream = result.decorated._stream
         stored_count = 0
+        count_stored_tests = getattr(result, "_count_stored_tests", int)
         from bzrlib.tests import selftest_debug_flags
         notify = "uncollected_cases" in selftest_debug_flags
         while tests:
@@ -96,7 +97,7 @@
                 self._tests = reversed(tests)
                 break
             case = _run_and_collect_case(tests.pop(), result)()
-            new_stored_count = getattr(result, "_count_stored_tests", int)()
+            new_stored_count = count_stored_tests()
             if case is not None and isinstance(case, unittest.TestCase):
                 if stored_count == new_stored_count and notify:
                     # Testcase didn't fail, but somehow is still alive

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2011-05-26 18:54:59 +0000
+++ bzrlib/tests/__init__.py	2011-05-26 20:41:53 +0000
@@ -3293,9 +3293,11 @@
                 os.waitpid(self.pid, 0)
 
     test_blocks = partition_tests(suite, concurrency)
+    # Clear the tests from the original suite so it doesn't keep them alive
     suite._tests[:] = []
     for process_tests in test_blocks:
         process_suite = TestUtil.TestSuite(process_tests)
+        # Also clear each split list so new suite has only reference
         process_tests[:] = []
         c2pread, c2pwrite = os.pipe()
         pid = os.fork()

